TreeMultimap
Date: 2016-05-24

com.google.common.collect

## Class TreeMultimap<K,V>

- java.lang.Object
- - com.google.common.collect.TreeMultimap<K,V>

- All Implemented Interfaces:
    Multimap<K,V>, SetMultimap<K,V>, SortedSetMultimap<K,V>, java.io.Serializable

      @GwtCompatible(serializable=true,
                     emulated=true)
      public class TreeMultimap<K,V>
      extends java.lang.Object

  Implementation of `Multimap` whose keys and values are ordered by their natural ordering or by supplied comparators. In all cases, this implementation uses `Comparable.compareTo(T)` or `Comparator.compare(T, T)` instead of `Object.equals(java.lang.Object)` to determine equivalence of instances.

  Warning: The comparators or comparables used must be consistent with equals as explained by the `Comparable` class specification. Otherwise, the resulting multiset will violate the general contract of `SetMultimap`, which it is specified in terms of `Object.equals(java.lang.Object)`.

  The collections returned by `keySet` and `asMap` iterate through the keys according to the key comparator ordering or the natural ordering of the keys. Similarly, `get`, `removeAll`, and `replaceValues` return collections that iterate through the values according to the value comparator ordering or the natural ordering of the values. The collections generated by `entries`, `keys`, and `values` iterate across the keys according to the above key ordering, and for each key they iterate across the values according to the value ordering.

  The multimap does not store duplicate key-value pairs. Adding a new key-value pair equal to an existing key-value pair has no effect.

  Null keys and values are permitted (provided, of course, that the respective comparators support them). All optional multimap methods are supported, and all returned views are modifiable.

  This class is not threadsafe when any concurrent operations update the multimap. Concurrent read operations will work correctly. To allow concurrent update operations, wrap your multimap with a call to `Multimaps.synchronizedSortedSetMultimap(com.google.common.collect.SortedSetMultimap<K, V>)`.

  See the Guava User Guide article on `Multimap`.

  Since:
    2.0
  See Also:
    Serialized Form

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.NavigableMap<K,java.util.Collection<V>>` | `asMap()` Returns a map view that associates each key with the corresponding values in the multimap.
    `void` | `clear()` Removes all key-value pairs from the multimap, leaving it empty.
    `boolean` | `containsEntry(java.lang.Object key, java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
    `boolean` | `containsKey(java.lang.Object key)` Returns `true` if this multimap contains at least one key-value pair with the key `key`.
    `boolean` | `containsValue(java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the value `value`.
    `static <K extends java.lang.Comparable,V extends java.lang.Comparable> TreeMultimap<K,V>` | `create()` Creates an empty `TreeMultimap` ordered by the natural ordering of its keys and values.
    `static <K,V> TreeMultimap<K,V>` | `create(java.util.Comparator<? super K> keyComparator, java.util.Comparator<? super V> valueComparator)` Creates an empty `TreeMultimap` instance using explicit comparators.
    `static <K extends java.lang.Comparable,V extends java.lang.Comparable> TreeMultimap<K,V>` | `create(Multimap<? extends K,? extends V> multimap)` Constructs a `TreeMultimap`, ordered by the natural ordering of its keys and values, with the same mappings as the specified multimap.
    `java.util.Set<java.util.Map.Entry<K,V>>` | `entries()` Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.
    `boolean` | `equals(java.lang.Object object)` Compares the specified object to this multimap for equality.
    `java.util.NavigableSet<V>` | `get(K key)` Returns a collection view of all values associated with a key.
    `int` | `hashCode()` Returns the hash code for this multimap.
    `boolean` | `isEmpty()` Returns `true` if this multimap contains no key-value pairs.
    `java.util.Comparator<? super K>` | `keyComparator()` Returns the comparator that orders the multimap keys.
    `Multiset<K>` | `keys()` Returns a view collection containing the key from each key-value pair in this multimap, without collapsing duplicates.
    `java.util.NavigableSet<K>` | `keySet()` Returns a view collection of all distinct keys contained in this multimap.
    `boolean` | `put(K key, V value)` Stores a key-value pair in the multimap.
    `boolean` | `putAll(K key, java.lang.Iterable<? extends V> values)` Stores a key-value pair in this multimap for each of `values`, all using the same key, `key`.
    `boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Stores all key-value pairs of `multimap` in this multimap, in the order returned by `multimap.entries()`.
    `boolean` | `remove(java.lang.Object key, java.lang.Object value)` Removes a single key-value pair with the key `key` and the value `value` from this multimap, if such exists.
    `java.util.SortedSet<V>` | `removeAll(java.lang.Object key)` Removes all values associated with a given key.
    `java.util.SortedSet<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
    `int` | `size()` Returns the number of key-value pairs in this multimap.
    `java.lang.String` | `toString()` Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
    `java.util.Comparator<? super V>` | `valueComparator()` Returns the comparator that orders the multimap values, with `null` indicating that natural ordering is used.
    `java.util.Collection<V>` | `values()` Returns a view collection containing the value from each key-value pair contained in this multimap, without collapsing duplicates (so `values().size() == size()`).

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.collect.SetMultimap

      `entries, equals`

    - ### Methods inherited from interface com.google.common.collect.Multimap

      `clear, containsEntry, containsKey, containsValue, hashCode, isEmpty, keys, put, putAll, putAll, remove, size`

- - ### Method Detail

    - #### create

          public static <K extends java.lang.Comparable,V extends java.lang.Comparable> TreeMultimap<K,V> create()

      Creates an empty `TreeMultimap` ordered by the natural ordering of its keys and values.

    - #### create

          public static <K,V> TreeMultimap<K,V> create(java.util.Comparator<? super K> keyComparator,
                                       java.util.Comparator<? super V> valueComparator)

      Creates an empty `TreeMultimap` instance using explicit comparators. Neither comparator may be null; use `Ordering.natural()` to specify natural order.
      Parameters:
        `keyComparator` - the comparator that determines the key ordering
        `valueComparator` - the comparator that determines the value ordering

    - #### create

          public static <K extends java.lang.Comparable,V extends java.lang.Comparable> TreeMultimap<K,V> create(Multimap<? extends K,? extends V> multimap)

      Constructs a `TreeMultimap`, ordered by the natural ordering of its keys and values, with the same mappings as the specified multimap.
      Parameters:
        `multimap` - the multimap whose contents are copied to this multimap

    - #### keyComparator

          public java.util.Comparator<? super K> keyComparator()

      Returns the comparator that orders the multimap keys.

    - #### valueComparator

          public java.util.Comparator<? super V> valueComparator()

      Description copied from interface: `SortedSetMultimap`
      Returns the comparator that orders the multimap values, with `null` indicating that natural ordering is used.

    - #### get

          @GwtIncompatible(value="NavigableSet")
          public java.util.NavigableSet<V> get(@Nullable
                                                           K key)

      Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

      Changes to the returned collection will update the underlying multimap, and vice versa.

      Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `get` in interface `Multimap<K,V>`
      Specified by:
        `get` in interface `SetMultimap<K,V>`
      Specified by:
        `get` in interface `SortedSetMultimap<K,V>`
      Since:
        14.0 (present with return type `SortedSet` since 2.0)

    - #### keySet

          @GwtIncompatible(value="NavigableSet")
          public java.util.NavigableSet<K> keySet()

      Returns a view collection of all distinct keys contained in this multimap. Note that the key set contains a key if and only if this multimap maps that key to at least one value.

      Changes to the returned set will update the underlying multimap, and vice versa. However, adding to the returned set is not possible.

      Because a `TreeMultimap` has unique sorted keys, this method returns a `NavigableSet`, instead of the `Set` specified in the `Multimap` interface.

      Specified by:
        `keySet` in interface `Multimap<K,V>`
      Since:
        14.0 (present with return type `SortedSet` since 2.0)

    - #### asMap

          @GwtIncompatible(value="NavigableMap")
          public java.util.NavigableMap<K,java.util.Collection<V>> asMap()

      Returns a map view that associates each key with the corresponding values in the multimap. Changes to the returned map, such as element removal, will update the underlying multimap. The map does not support `setValue` on its entries, `put`, or `putAll`.

      When passed a key that is present in the map, `asMap().get(Object)` has the same behavior as `get(K)`, returning a live collection. When passed a key that is not present, however, `asMap().get(Object)` returns `null` instead of an empty collection.

      Though the method signature doesn't say so explicitly, the returned map has `SortedSet` values.

      Because a `TreeMultimap` has unique sorted keys, this method returns a `NavigableMap`, instead of the `Map` specified in the `Multimap` interface.

      Specified by:
        `asMap` in interface `Multimap<K,V>`
      Specified by:
        `asMap` in interface `SetMultimap<K,V>`
      Specified by:
        `asMap` in interface `SortedSetMultimap<K,V>`
      Since:
        14.0 (present with return type `SortedMap` since 2.0)

    - #### removeAll

          public java.util.SortedSet<V> removeAll(@Nullable
                                         java.lang.Object key)

      Removes all values associated with a given key. The returned collection is immutable.

      Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Specified by:
        `removeAll` in interface `SetMultimap<K,V>`
      Specified by:
        `removeAll` in interface `SortedSetMultimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.

    - #### replaceValues

          public java.util.SortedSet<V> replaceValues(@Nullable
                                             K key,
                                             java.lang.Iterable<? extends V> values)

      Stores a collection of values with the same key, replacing any existing values for that key. The returned collection is immutable.

      Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

      Any duplicates in `values` will be stored in the multimap once.

      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Specified by:
        `replaceValues` in interface `SetMultimap<K,V>`
      Specified by:
        `replaceValues` in interface `SortedSetMultimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

    - #### values

          public java.util.Collection<V> values()

      Returns a view collection containing the value from each key-value pair contained in this multimap, without collapsing duplicates (so `values().size() == size()`).

      Changes to the returned collection will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on. Consequently, the values do not follow their natural ordering or the ordering of the value comparator.

      Specified by:
        `values` in interface `Multimap<K,V>`

    - #### entries

          public java.util.Set<java.util.Map.Entry<K,V>> entries()

      Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.

      Changes to the returned collection or the entries it contains will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on.

      Each entry is an immutable snapshot of a key-value mapping in the multimap, taken at the time the entry is returned by a method call to the collection or its iterator.

      Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

      Specified by:
        `entries` in interface `Multimap<K,V>`
      Specified by:
        `entries` in interface `SetMultimap<K,V>`

    - #### put

          public boolean put(@Nullable
                    K key,
                    @Nullable
                    V value)

      Stores a key-value pair in the multimap.
      Specified by:
        `put` in interface `Multimap<K,V>`
      Parameters:
        `key` - key to store in the multimap
        `value` - value to store in the multimap
      Returns:
        `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object object)

      Compares the specified object to this multimap for equality.

      Two `SetMultimap` instances are equal if, for each key, they contain the same values. Equality does not depend on the ordering of keys or values.

      Specified by:
        `equals` in interface `Multimap<K,V>`
      Specified by:
        `equals` in interface `SetMultimap<K,V>`

    - #### size

          public int size()

      Description copied from interface: `Multimap`
      Returns the number of key-value pairs in this multimap.

      Note: this method does not return the number of distinct keys in the multimap, which is given by `keySet().size()` or `asMap().size()`. See the opening section of the `Multimap` class documentation for clarification.

      Specified by:
        `size` in interface `Multimap<K,V>`

    - #### containsKey

          public boolean containsKey(@Nullable
                            java.lang.Object key)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key`.
      Specified by:
        `containsKey` in interface `Multimap<K,V>`

    - #### clear

          public void clear()

      Description copied from interface: `Multimap`
      Removes all key-value pairs from the multimap, leaving it empty.
      Specified by:
        `clear` in interface `Multimap<K,V>`

    - #### isEmpty

          public boolean isEmpty()

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains no key-value pairs. Equivalent to `size() == 0`, but can in some cases be more efficient.
      Specified by:
        `isEmpty` in interface `Multimap<K,V>`

    - #### containsValue

          public boolean containsValue(@Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the value `value`.
      Specified by:
        `containsValue` in interface `Multimap<K,V>`

    - #### containsEntry

          public boolean containsEntry(@Nullable
                              java.lang.Object key,
                              @Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
      Specified by:
        `containsEntry` in interface `Multimap<K,V>`

    - #### remove

          public boolean remove(@Nullable
                       java.lang.Object key,
                       @Nullable
                       java.lang.Object value)

      Description copied from interface: `Multimap`
      Removes a single key-value pair with the key `key` and the value `value` from this multimap, if such exists. If multiple key-value pairs in the multimap fit this description, which one is removed is unspecified.
      Specified by:
        `remove` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### putAll

          public boolean putAll(@Nullable
                       K key,
                       java.lang.Iterable<? extends V> values)

      Description copied from interface: `Multimap`
      Stores a key-value pair in this multimap for each of `values`, all using the same key, `key`. Equivalent to (but expected to be more efficient than):

             for (V value : values) {
               put(key, value);
             }

      In particular, this is a no-op if `values` is empty.

      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### putAll

          public boolean putAll(Multimap<? extends K,? extends V> multimap)

      Description copied from interface: `Multimap`
      Stores all key-value pairs of `multimap` in this multimap, in the order returned by `multimap.entries()`.
      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### keys

          public Multiset<K> keys()

      Description copied from interface: `Multimap`
      Returns a view collection containing the key from each key-value pair in this multimap, without collapsing duplicates. This collection has the same size as this multimap, and `keys().count(k) == get(k).size()` for all `k`.

      Changes to the returned multiset will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      Specified by:
        `keys` in interface `Multimap<K,V>`

    - #### hashCode

          public int hashCode()

      Returns the hash code for this multimap.

      The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

      Specified by:
        `hashCode` in interface `Multimap<K,V>`
      Overrides:
        `hashCode` in class `java.lang.Object`
      See Also:
        `Map.hashCode()`

    - #### toString

          public java.lang.String toString()

      Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the multimap